【leetcode 力扣刷题】数学题之计算次幂//次方:快速幂

利用乘法求解次幂问题---快速幂

  • [50. Pow(x, n)](#50. Pow(x, n))
  • [372. 超级次方](#372. 超级次方)

50. Pow(x, n)

题目链接:50. Pow(x, n)

题目内容:

题目就是要求我们去实现计算x的n次方的功能函数,类似c++的power()函数。但是我们不能使用power()函数直接得到答案,那样这道题就失去了考察的意义。

前面提到乘法a*b可以看作是b个a相加,用加法来完成乘法;x的n次方,就是n个x相乘,那么同样可以用乘法来代替次幂计算,我们称之为快速幂 。比如5^7,就是7个5相乘,快速幂的过程如下:

第一轮是乘以5,第二轮乘以5*5,第三轮乘以(5*5)*(5*5),也就是每一轮乘的数都在加倍,这样就能够在log^n的时间复杂度内完成x^n的计算。代码实现如下(C++):

cpp 复制代码
class Solution {
public:
    double myPow(double x, int n) {
    	//先处理特殊情况
        if(x == 0) return 0.0;
        if(x == 1) return 1.0;
        if(n == 0) return 1.0;
        bool flage = false;
        long _n = n;
        //如果n是负数,x^n = 1/(x^|n|)
        if(_n < 0){
            flage = true;
            _n = -_n;
        }
        double ans = 1;
        double mul = x;
        //快速幂主体过程
        while(_n){  
            if(_n&1)  //如果n末位为1,就乘以mul
                ans *= mul;      
            mul *= mul; //mul翻倍
            _n >>= 1; //n右移一位
        }
        return flage ? 1.0/ans : ans; //判断是否需要变成倒数
    }
};

372. 超级次方

题目链接:372. 超级次方

题目内容:

看起来和上一题是差不多的,但是由于b是一个非常大的正整数,以数组形式给出1,0,3,4就表示1034【末位是个位,然后是十位,然后是百位,最前面的是最高位】。其中1 <= b.length <= 2000说明b可以达到10^1999的程度,根本没法用double、long long等数据类型来存储这么大的数,所以在运算过程中也不能直接把b转换成一个数或者每一位转换成一个数,需要其他方法:

将每一位bi的数值bi*10^(m-1-i)【其中m是b.length】分解成bi和10^(m-1-i)两部分,每次先求a^(10^(m-1-i))得到A,再求A^bi。a^(10^(m-1-i))随着i的减小越来越大,但是可以看作是上一轮的A^10。

由于每次次幂结果都要mod 1337,所以结果是不会溢出的,a^(10^(m-1-i))每一次用上一轮的A^10来表示就解决了b很大的问题。另外需要注意的是(a*b) mod k =( (a mod k) * (b mod k) ) mod k。

a^(10^(m-1-i))和A^bi以及A^10都用快速幂求解。快速幂过程中根据(a*b) mod k =( (a mod k) * (b mod k) ) mod k加上求模操作。代码如下(C++):

cpp 复制代码
class Solution {
public:
	//快速幂
    long quick_pow(int a, int n){
        int ans = 1;
        int mul = a;
        while(n){
            if(n&1)
            	//加上求模操作
                ans = ( (ans % 1337) * (mul % 1337)) % 1337;
            //mul也加上求模操作
            mul = ((mul % 1337) * (mul % 1337)) % 1337;
            n>>=1;
        }
        return ans;
    }
    int superPow(int a, vector<int>& b) {
        int ans = 1;        
        for(int j = b.size() - 1; j >= 0; j--){
            ans =( (ans % 1337) * (quick_pow(a,b[j]) % 1337) ) % 1337;
            //每次a都在上一次的基础上,变成其10次方
            a = quick_pow(a, 10);
        }
        return ans;
    }
};
相关推荐
强哥聊算力3 小时前
《算力江湖·英伟达传奇》第七集:ChatGPT出现前夜,英伟达发生了什么?
服务器·人工智能·算法·ai·chatgpt·gpu算力
Navigator_Z7 小时前
LeetCode //C - 1289. Minimum Falling Path Sum II
c语言·算法·leetcode
CCblandy7 小时前
令牌桶在 0.9 倍负载超发 19%、固定窗口边界放行 20 个:四种限流算法同构实测
后端·python·算法·性能优化·架构
mmmmath_37 小时前
LeetCode.104.二叉树的最大深度
数据结构·leetcode
YangYang9YangYan8 小时前
2027供应链计划校招:数学与应用数学专业如何把预测模型讲成业务决策?
人工智能·sql·算法
jsjzsl28 小时前
递归自改进系统(RSI)的本质是自发对称破缺:智能爆炸有界—— AI研发切记盲目投入
人工智能·python·算法
程序员清风8 小时前
最短路径算法:BFS、Dijkstra 与 Floyd
java·算法·宽度优先
梦帮科技8 小时前
Kali Linux Scapy 畸形报文构造学——深度解剖非法 TCP Flags 与反常序列号
linux·爬虫·神经网络·算法·数学建模·系统架构·模拟退火算法
171320330计算机毕设编程10 小时前
计算机毕业设计 基于YOLO改进算法的车辆特征识别系统设计与实现--lw
java·大数据·python·sql·算法